diff -ruN ../nakedmudv2.4/src/olc2/redit.c src/olc2/redit.c
--- ../nakedmudv2.4/src/olc2/redit.c	Sat Jun  4 23:40:29 2005
+++ src/olc2/redit.c	Sat Jun 18 14:46:43 2005
@@ -645,7 +645,7 @@
 COMMAND(cmd_redit) {
   ZONE_DATA *zone;
   ROOM_DATA *room;
-  room_vnum vnum;
+  int vnum;
 
   // if no argument is supplied, default to the current room
   if(!arg || !*arg)
diff -ruN ../nakedmudv2.4/src/olc2/zedit.c src/olc2/zedit.c
--- ../nakedmudv2.4/src/olc2/zedit.c	Sat Jun  4 23:40:29 2005
+++ src/olc2/zedit.c	Sat Jun 18 14:46:43 2005
@@ -83,8 +83,8 @@
 COMMAND(cmd_zedit) {
   // we want to create a new zone?
   if(!strncasecmp(arg, "new ", 4)) {
-    zone_vnum vnum = 0;
-    room_vnum min = 0, max = 0;
+    int vnum = 0;
+    int min = 0, max = 0;
 
     // scan for the parameters
     sscanf(arg+4, "%d %d %d", &vnum, &min, &max);
@@ -114,7 +114,7 @@
   // we want to edit a preexisting zone
   else {
     ZONE_DATA *zone = NULL;
-    zone_vnum vnum   = (!*arg ? 
+    int vnum   = (!*arg ? 
 			zoneGetVnum(worldZoneBounding(gameworld, roomGetVnum(charGetRoom(ch)))) : atoi(arg));
  
     // make sure there is a corresponding zone ...
diff -ruN ../nakedmudv2.4/src/room.c src/room.c
--- ../nakedmudv2.4/src/room.c	Sat Jun  4 23:40:30 2005
+++ src/room.c	Sat Jun 18 14:46:43 2005
@@ -37,7 +37,7 @@
 
 
 struct room_data {
-  room_vnum   vnum;              // what vnum are we?
+  int   vnum;              // what vnum are we?
 
   int         terrain;           // what kind of terrain do we have?
   char       *name;              // what is the name of our room?
@@ -252,7 +252,7 @@
 }
 
 
-void       roomDigExit        (ROOM_DATA *room, int dir, room_vnum to) {
+void       roomDigExit        (ROOM_DATA *room, int dir, int to) {
   // we already have an exit in that direction... change the destination
   if(roomGetExit(room, dir))
     exitSetTo(roomGetExit(room, dir), to);
@@ -264,7 +264,7 @@
   }
 }
 
-void roomDigExitSpecial (ROOM_DATA *room, const char *dir, room_vnum to) {
+void roomDigExitSpecial (ROOM_DATA *room, const char *dir, int to) {
   // we already have an exit in that direction ... change the destination
   if(roomGetExitSpecial(room, dir))
     exitSetTo(roomGetExitSpecial(room, dir), to);
@@ -332,7 +332,7 @@
   return room->characters;
 };
 
-room_vnum   roomGetVnum        (const ROOM_DATA *room) {
+int   roomGetVnum        (const ROOM_DATA *room) {
   return room->vnum;
 };
 
@@ -393,7 +393,7 @@
   room->edescs = edescs;
 }
 
-void        roomSetVnum        (ROOM_DATA *room, room_vnum vnum) {
+void        roomSetVnum        (ROOM_DATA *room, int vnum) {
   room->vnum = vnum;
 };
 
diff -ruN ../nakedmudv2.4/src/room.h src/room.h
--- ../nakedmudv2.4/src/room.h	Sat Jun  4 23:40:30 2005
+++ src/room.h	Sat Jun 18 14:46:43 2005
@@ -105,8 +105,8 @@
 void       roomAddChar        (ROOM_DATA *room, CHAR_DATA *ch);
 void       roomAddObj         (ROOM_DATA *room, OBJ_DATA *obj);
 
-void       roomDigExit        (ROOM_DATA *room, int dir, room_vnum to);
-void       roomDigExitSpecial (ROOM_DATA *room, const char *dir, room_vnum to);
+void       roomDigExit        (ROOM_DATA *room, int dir, int to);
+void       roomDigExitSpecial (ROOM_DATA *room, const char *dir, int to);
 
 //*****************************************************************************
 //
@@ -114,7 +114,7 @@
 //
 //*****************************************************************************
 
-room_vnum   roomGetVnum        (const ROOM_DATA *room);
+int   roomGetVnum        (const ROOM_DATA *room);
 const char *roomGetName        (const ROOM_DATA *room);
 const char *roomGetDesc        (const ROOM_DATA *room);
 int         roomGetTerrain     (const ROOM_DATA *room);
@@ -135,7 +135,7 @@
 void        roomAddReset       (ROOM_DATA *room, RESET_DATA *reset);
 
 void        roomSetEdescs      (ROOM_DATA *room, EDESC_SET *edescs);
-void        roomSetVnum        (ROOM_DATA *room, room_vnum vnum);
+void        roomSetVnum        (ROOM_DATA *room, int vnum);
 void        roomSetName        (ROOM_DATA *room, const char *name);
 void        roomSetDesc        (ROOM_DATA *room, const char *desc);
 void        roomSetTerrain     (ROOM_DATA *room, int terrain_type);
diff -ruN ../nakedmudv2.4/src/scripts/module.mk src/scripts/module.mk
--- ../nakedmudv2.4/src/scripts/module.mk	Sat Jun  4 23:40:48 2005
+++ src/scripts/module.mk	Sat Jun 18 15:03:10 2005
@@ -104,7 +104,8 @@
 # Object files we generate
 SRC      += scripts/script_set.c scripts/script.c scripts/pychar.c \
 	    scripts/pyobj.c scripts/pymud.c scripts/pyroom.c \
-	    scripts/script_editor.c scripts/script_edit.c scripts/pyplugs.c
+	    scripts/script_editor.c scripts/script_edit.c scripts/pyplugs.c \
+	    scripts/pyevent.c scripts/pystorage.c scripts/pyauxiliary.c
 
 # the top level directory of python.
 PYTHONTOP = /usr/local/include
diff -ruN ../nakedmudv2.4/src/scripts/pyauxiliary.c src/scripts/pyauxiliary.c
--- ../nakedmudv2.4/src/scripts/pyauxiliary.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyauxiliary.c	Sat Jun 18 14:46:43 2005
@@ -0,0 +1,174 @@
+//*****************************************************************************
+//
+// pyauxiliary.c
+//
+// This is a wrapper around the auxiliary data system so python can make use
+// of it. Allows python modules to install new auxiliary data on characters,
+// rooms, objects, etc...
+//
+//*****************************************************************************
+
+#include <Python.h>
+#include <structmember.h>
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../storage.h"
+#include "../auxiliary.h"
+
+#include "pystorage.h"
+
+
+
+//*****************************************************************************
+// local variables and datastructures
+//*****************************************************************************
+
+// the minimum size of our aux table
+#define MIN_AUX_TABLE_SIZE       50
+
+// holds a map from auxiliary data names to their prototype
+HASHTABLE *aux_table = NULL;
+
+
+
+//*****************************************************************************
+// the wrapper layer between python and C auxiliary data
+//*****************************************************************************
+PyObject *newPyAuxiliaryData(const char *keyword) {
+  // look up the prototype
+  PyObject *proto = hashGet(aux_table, keyword);
+  
+  // make sure we've got an OK proto
+  if(proto == NULL)
+    return NULL;
+  else {
+    // create a new instance of the proto
+    PyObject *instance = PyInstance_New(proto, NULL, NULL);
+    return instance;
+  }
+}
+
+void deletePyAuxiliaryData(PyObject *data) {
+  Py_DECREF(data);
+}
+
+void pyAuxiliaryDataCopyTo(PyObject *from, PyObject *to) {
+  PyObject *retval = PyObject_CallMethod(from, "copyTo", "O", to);
+  Py_XDECREF(retval);
+}
+
+PyObject *pyAuxiliaryDataCopy(PyObject *data) {
+  PyObject *retval = PyObject_CallMethod(data, "copy", NULL);
+  return retval;
+}
+
+STORAGE_SET *pyAuxiliaryDataStore(PyObject *data) {
+  PyObject  *pyset = PyObject_CallMethod(data, "store", NULL);
+  STORAGE_SET *set = NULL;
+
+  // make sure the set exists
+  if(pyset == NULL || pyset == Py_None)
+    set = new_storage_set();
+  else
+    set = PyStorageSet_AsSet(pyset);
+  Py_XDECREF(pyset);
+  return set;
+}
+
+PyObject *pyAuxiliaryDataRead(const char *keyword, STORAGE_SET *set) {
+  // look up the prototype
+  PyObject *proto = hashGet(aux_table, keyword);
+  
+  // make sure we've got an OK proto
+  if(proto == NULL)
+    return NULL;
+  else {
+    // build our arguments and keywords
+    PyObject     *args = Py_BuildValue("(O)", newPyStorageSet(set));
+    PyObject *instance = PyInstance_New(proto, args, NULL);
+    Py_DECREF(args);
+    return instance;
+  }
+}
+
+
+
+//*****************************************************************************
+//  implementation of the pyauxiliary method 
+//*****************************************************************************
+
+//
+// install new python auxiliary data. Auxiliary data must be a python CLASS
+// OBJECT that has 4 functions:
+//   __init__   this function initializes the auxiliary data. It takes an
+//              optional argument that is a storage set which should be used
+//              to initialize the values of the auxiliary data if it is supplied
+//   copy       returns a copy of the auxiliary data
+//   copyTo     the values of the auxiliary data to another auxiliary data
+//              supplied as an argument to the function
+//   store      returns a storage set representation of the auxiliary data
+PyObject *PyAuxiliary_install(PyObject *self, PyObject *args) {
+  PyObject   *proto = NULL; // the class proto
+  char        *name = NULL; // the name of the auxiliary data
+  char *installs_on = NULL; // a list of datatypes it installs onto
+  bitvector_t  type = 0;    // bitvector representation of we we install on
+
+  // try parsing the install
+  if(!PyArg_ParseTuple(args, "sOs", &name, &proto, &installs_on)) {
+    PyErr_Format(PyExc_TypeError,
+		 "Installed auxiliaries require a name, a proto class, and "
+		 "a comma-separated list of datatypes to install onto");
+    return NULL;
+  }
+
+  // parse the data types that this auxiliary data installs to
+  if(is_keyword(installs_on, "character", FALSE))
+    SET_BIT(type, AUXILIARY_TYPE_CHAR);
+  if(is_keyword(installs_on, "room",      FALSE))
+    SET_BIT(type, AUXILIARY_TYPE_ROOM);
+  if(is_keyword(installs_on, "object",    FALSE))
+    SET_BIT(type, AUXILIARY_TYPE_OBJ);
+  // more types to come soon!!
+  //***********
+  // FINISH ME
+  //***********
+
+  // add proto to our table
+  Py_INCREF(proto);
+  hashPut(aux_table, name, proto);
+  AUXILIARY_FUNCS *funcs = newAuxiliaryFuncs(type, 
+	newPyAuxiliaryData, deletePyAuxiliaryData,
+	pyAuxiliaryDataCopyTo, pyAuxiliaryDataCopy,
+	pyAuxiliaryDataStore, pyAuxiliaryDataRead);
+  auxiliaryFuncSetIsPy(funcs, TRUE);
+					     
+  auxiliariesInstall(name, funcs);
+  return Py_BuildValue("i", 1);
+}
+
+PyMethodDef pyauxiliary_module_methods[] = {
+  { "install", PyAuxiliary_install, METH_VARARGS,
+    "installs new python auxiliary data into the mud. Auxiliary Data must "
+    "take the form of an uninstanced class that has a ClassXXX(set = None) "
+    "init function, a copy() function, a copyTo(to) function, and a store() "
+    "function" },
+  {NULL, NULL, 0, NULL}  /* Sentinel */
+};
+
+
+//*****************************************************************************
+// implementation of pyauxiliary.h
+//*****************************************************************************
+
+// initialize python auxiliary data for use
+PyMODINIT_FUNC init_PyAuxiliary(void) {
+  aux_table = newHashtableSize(MIN_AUX_TABLE_SIZE);
+  Py_InitModule3("auxiliary", pyauxiliary_module_methods,
+		 "The module for installing auxiliary data");
+}
+
+// returns TRUE if auxiliary data of the given name has been installed by python
+bool pyAuxiliaryDataExists(const char *name) {
+  return hashIn(aux_table, name);
+}
diff -ruN ../nakedmudv2.4/src/scripts/pyauxiliary.h src/scripts/pyauxiliary.h
--- ../nakedmudv2.4/src/scripts/pyauxiliary.h	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyauxiliary.h	Sat Jun 18 14:46:43 2005
@@ -0,0 +1,19 @@
+#ifndef PYAUXILIARY_H
+#define PYAUXILIARY_H
+//*****************************************************************************
+//
+// pyauxiliary.h
+//
+// This is a wrapper around the auxiliary data system so python can make use
+// of it. Allows python modules to install new auxiliary data on characters,
+// rooms, objects, etc...
+//
+//*****************************************************************************
+
+// initialize python auxiliary data for use
+PyMODINIT_FUNC init_PyAuxiliary(void);
+
+// returns TRUE if auxiliary data of the given name has been installed by python
+bool pyAuxiliaryDataExists(const char *name);
+
+#endif // PYAUXILIARY_H
diff -ruN ../nakedmudv2.4/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv2.4/src/scripts/pychar.c	Sat Jun  4 23:40:29 2005
+++ src/scripts/pychar.c	Sat Jun 18 15:28:32 2005
@@ -14,10 +14,13 @@
 #include "../world.h"
 #include "../room.h"
 #include "../character.h"
+#include "../body.h"
 #include "../object.h"
 #include "../races.h"
 #include "../handler.h"
 #include "../utils.h"
+#include "../action.h"
+#include "../socket.h"
 
 #include "pyplugs.h"
 #include "script.h"
@@ -25,6 +28,7 @@
 #include "pychar.h"
 #include "pyroom.h"
 #include "pyobj.h"
+#include "pyauxiliary.h"
 
 
 
@@ -169,6 +173,24 @@
   else           return NULL;
 }
 
+PyObject *PyChar_gethisher(PyChar *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL) return Py_BuildValue("s", HISHER(ch));
+  else           return NULL;
+}
+
+PyObject *PyChar_gethimher(PyChar *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL) return Py_BuildValue("s", HIMHER(ch));
+  else           return NULL;
+}
+
+PyObject *PyChar_getheshe(PyChar *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL) return Py_BuildValue("s", HESHE(ch));
+  else           return NULL;
+}
+
 PyObject *PyChar_geton(PyChar *self, void *closure) {
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch == NULL) 
@@ -546,6 +568,49 @@
   }
 }
 
+//
+// Returns TRUE if the character has the given variable set
+PyObject *PyChar_hasvar(PyChar *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Character variables must have string names.");
+    return NULL;
+  }
+
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL)
+    return Py_BuildValue("b", charHasVar(ch, var));
+
+  PyErr_Format(PyExc_TypeError, 
+	       "Tried to get a variable value for nonexistant character, %d",
+	       self->uid);
+  return NULL;
+}
+
+
+//
+// Delete the variable set on the character with the specified name
+PyObject *PyChar_deletevar(PyChar *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Character variables must have string names.");
+    return NULL;
+  }
+
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL) {
+    charDeleteVar(ch, var);
+    return Py_BuildValue("i", 1);
+  }
+
+  PyErr_Format(PyExc_TypeError, 
+	       "Tried to get a variable value for nonexistant character, %d",
+	       self->uid);
+  return NULL;
+}
+
 
 //
 // Get the value of a variable stored on the character
@@ -615,6 +680,79 @@
 }
 
 
+//
+// equips a character with an item
+PyObject *PyChar_equip(PyChar *self, PyObject *args) {  
+  OBJ_DATA  *obj = NULL;
+  CHAR_DATA  *ch = NULL;
+  PyObject *pobj = NULL;
+  char      *pos = NULL;
+
+  // incase the equip fails, keep item in the original place.. here's the vars
+  CHAR_DATA *old_carrier = NULL;
+  CHAR_DATA  *old_wearer = NULL;
+  const char    *old_pos = NULL;
+  ROOM_DATA    *old_room = NULL;
+  OBJ_DATA     *old_cont = NULL;
+
+  if (!PyArg_ParseTuple(args, "O|s", &pobj, &pos)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Character equip must be supplied with an item to equip!");
+    return NULL;
+  }
+
+  if(!PyObj_Check(pobj)) {
+    PyErr_Format(PyExc_TypeError,
+		 "Only objects may be equipped to characters!");
+    return NULL;
+  }
+
+  ch = PyChar_AsChar((PyObject *)self);
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to equip nonexistant character!");
+    return NULL;
+  }
+
+  obj = PyObj_AsObj(pobj);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to equip character with existant object!");
+    return NULL;
+  }
+
+  // remove the object from whatever it's in/on currently
+  if((old_room = objGetRoom(obj)) != NULL)
+    obj_from_room(obj);
+  if((old_cont = objGetContainer(obj)) != NULL)
+    obj_from_obj(obj);
+  if((old_carrier = objGetCarrier(obj)) != NULL)
+    obj_from_char(obj);
+  if((old_wearer = objGetWearer(obj)) != NULL) {
+    old_pos = bodyEquippedWhere(charGetBody(old_wearer), obj);
+    try_unequip(old_wearer, obj);
+  }
+
+  // try equipping the object. If we fail, put it back wherever it came from
+  if(!objIsType(obj, "worn") || !try_equip(ch, obj, pos)) {
+    if(old_room != NULL)
+      obj_to_room(obj, old_room);
+    else if(old_cont != NULL)
+      obj_to_obj(obj, old_cont);
+    else if(old_carrier != NULL)
+      obj_to_char(obj, old_carrier);
+    else if(old_wearer != NULL)
+      try_equip(ch, obj, old_pos);
+    PyErr_Format(PyExc_StandardError,
+		 "Character is already equipped in all possible positions!");
+    return NULL;
+  }
+  // success
+  else 
+    return Py_BuildValue("i", 1);
+}
+
+
 PyObject *PyChar_attach(PyChar *self, PyObject *args) {  
   long vnum = NOTHING;
 
@@ -633,7 +771,7 @@
     return Py_BuildValue("i", 1);
   }
   else {
-    PyErr_Format(PyExc_TypeError, 
+    PyErr_Format(PyExc_StandardError, 
 		 "Tried to attach script to nonexistant char, %d, or script %d "
 		 "does not exit.", self->uid, (int)vnum);
     return NULL;
@@ -659,7 +797,7 @@
     return Py_BuildValue("i", 1);
   }
   else {
-    PyErr_Format(PyExc_TypeError, 
+    PyErr_Format(PyExc_StandardError, 
 		 "Tried to detach script from nonexistant char, %d, or script "
 		 "%d does not exit.", self->uid, (int)vnum);
     return NULL;
@@ -667,6 +805,156 @@
 }
 
 
+//
+// handles the completion of an action queued up by Python
+void PyAction_on_complete(CHAR_DATA *ch, PyObject *tuple, bitvector_t where,
+			  const char *arg) {
+  PyObject *pychar = NULL; // the python representation of our ch
+  PyObject  *cfunc = NULL; // the function called on completion
+  PyObject  *ifunc = NULL; // the function called on interruption
+  PyObject   *data = NULL; // the data we need to send back
+
+  // only run the action of our arguments parse properly
+  if(PyArg_ParseTuple(tuple, "OOOO", &pychar, &data, &cfunc, &ifunc)) {
+    if(cfunc != Py_None) {
+      PyObject *ret = PyObject_CallFunction(cfunc, "OOs", pychar, data, arg);
+      Py_XDECREF(ret);
+    }
+  }
+  
+  Py_DECREF(tuple);
+}
+
+
+//
+// handles the interruption of an action queued up by Python
+void PyAction_on_interrupt(CHAR_DATA *ch, PyObject *tuple, bitvector_t where,
+			   const char *arg) {
+  PyObject *pychar = NULL; // the python representation of our ch
+  PyObject  *cfunc = NULL; // the function called on completion
+  PyObject  *ifunc = NULL; // the function called on interruption
+  PyObject   *data = NULL; // the data we need to send back
+
+  // only run the action of our arguments parse properly
+  if(PyArg_ParseTuple(tuple, "OOOO", &pychar, &data, &cfunc, &ifunc)) {
+    if(ifunc != Py_None) {
+      PyObject *ret = PyObject_CallFunction(ifunc, "OOs", pychar, data, arg);
+      Py_XDECREF(ret);
+    }
+  }
+  
+  Py_DECREF(tuple);
+}
+
+
+//
+// start a new action (and interrupt old ones)
+PyObject *PyChar_start_action(PyChar *self, PyObject *args) {  
+  CHAR_DATA          *ch = NULL;    // our normal character representation
+  PyObject  *on_complete = Py_None; // func called when action is completed
+  PyObject *on_interrupt = Py_None; // func called when action is interrupted
+  PyObject         *data = Py_None; // the function's data value
+  double           delay = 0;       // the delay of the action (seconds)
+  char              *arg = NULL;    // the action's string argument
+
+  // parse all of our values
+  if(!PyArg_ParseTuple(args, "dO|OOs", &delay,  &on_complete, &on_interrupt,
+		      &data, &arg)) {
+    PyErr_Format(PyExc_TypeError,
+		 "startAction supplied with invalid arguments!");
+    return NULL;
+  }
+
+  // make sure we exist
+  if((ch = PyChar_AsChar((PyObject *)self)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to start action for nonexistant character!");
+    return NULL;
+  }
+
+  // now, queue up the action
+  start_action(ch, (int)(delay SECONDS), 1, 
+	       PyAction_on_complete, PyAction_on_interrupt, 
+	       Py_BuildValue("OOOO", self, data, on_complete, on_interrupt),
+	       arg);
+
+  // success!
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// check to see if a character currently has an action in progress
+PyObject *PyChar_is_acting(PyChar *self, PyObject *args) {  
+  // make sure we exist
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+
+  // make sure the character exists
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to query action status for a nonexistant character.");
+    return NULL;
+  }
+
+  // return our value
+  return Py_BuildValue("i", is_acting(ch, 1));
+}
+
+
+//
+// interrupt any actions the character is currently performing
+PyObject *PyChar_interrupt_action(PyChar *self, PyObject *args) {  
+  // make sure we exist
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+
+  // make sure the character exists
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to interrupt actions for a nonexistant character.");
+    return NULL;
+  }
+
+  interrupt_action(ch, 1);
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// returns the specified piece of auxiliary data from the character
+// if it is a piece of python auxiliary data.
+PyObject *PyChar_get_auxiliary(PyChar *self, PyObject *args) {
+  char *keyword = NULL;
+  if(!PyArg_ParseTuple(args, "s", &keyword)) {
+    PyErr_Format(PyExc_TypeError,
+		 "getAuxiliary() must be supplied with the name that the "
+		 "auxiliary data was installed under!");
+    return NULL;
+  }
+
+  // make sure we exist
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to get auxiliary data for a nonexistant character.");
+    return NULL;
+  }
+
+  // make sure the auxiliary data exists
+  if(!pyAuxiliaryDataExists(keyword)) {
+    PyErr_Format(PyExc_StandardError,
+		 "No auxiliary data named '%s' exists!", keyword);
+    return NULL;
+  }
+
+  PyObject *data = charGetAuxiliaryData(ch, keyword);
+  if(data == NULL) {
+    printf("Data is NULL for %s!!\r\n", keyword);
+    data = Py_None;
+  }
+  return Py_BuildValue("O", data);
+}
+
+
 
 //*****************************************************************************
 // comparators, getattr, setattr, and all that other class stuff
@@ -719,7 +1007,7 @@
 // methods in the char module
 //*****************************************************************************
 PyObject *PyChar_load_mob(PyObject *self, PyObject *args) {
-  int mob_vnum    = NOBODY, room_vnum = NOWHERE;
+  int mob_vnum    = NOBODY, to_vnum = NOWHERE;
   PyObject *to    = NULL;
 
   ROOM_DATA *room  = NULL;
@@ -734,9 +1022,9 @@
 
   // see what we're trying to load to
   if(PyInt_Check(to))
-    room_vnum = (int)PyInt_AsLong(to);
+    to_vnum = (int)PyInt_AsLong(to);
   else if(PyRoom_Check(to))
-    room_vnum = (int)PyRoom_AsVnum(to);
+    to_vnum = (int)PyRoom_AsVnum(to);
   else if(PyObj_Check(to))
     on = propertyTableGet(obj_table, PyObj_AsUid(to));
   else {
@@ -758,7 +1046,7 @@
   if(on)
     room = objGetRoom(on);
   else
-    room = worldGetRoom(gameworld, room_vnum);
+    room = worldGetRoom(gameworld, to_vnum);
 
   if(room == NULL) {
     PyErr_Format(PyExc_TypeError, 
@@ -867,9 +1155,23 @@
   return Py_BuildValue("O", list);
 }
 
+PyObject *PyChar_all_sockets(PyObject *self) {
+  PyObject        *list = PyList_New(0);
+  LIST_ITERATOR *sock_i = newListIterator(socket_list);
+  SOCKET_DATA     *sock = NULL;
+  ITERATE_LIST(sock, sock_i) {
+    // only add sockets with attached characters who are in game
+    if(socketGetChar(sock) && charGetRoom(socketGetChar(sock)))
+      PyList_Append(list, newPyChar(socketGetChar(sock)));
+  } deleteListIterator(sock_i);
+  return Py_BuildValue("O", list);
+}
+
 PyMethodDef char_module_methods[] = {
-  { "all_chars", (PyCFunction)PyChar_all_chars, METH_NOARGS,
+  { "char_list", (PyCFunction)PyChar_all_chars, METH_NOARGS,
     "Return a python list containing an entry for every character in game." },
+  { "socket_list", (PyCFunction)PyChar_all_sockets, METH_NOARGS,
+    "Returns a list of all characters with attached sockets." },
   { "load_mob", PyChar_load_mob, METH_VARARGS,
     "load a mobile with the specified vnum to a room." },
   { "count_mobs", PyChar_count_mobs, METH_VARARGS,
@@ -952,6 +1254,15 @@
 		      "Returns 1 if the char is an NPC, and 0 otherwise.");
   PyChar_addGetSetter("is_pc", PyChar_getispc, NULL,
 		      "Returns 1 if the char is a PC, and 0 otherwise.");
+  PyChar_addGetSetter("hisher", PyChar_gethisher, NULL,
+		      "Returns 'his' if the char is male, 'her' if female, and "
+		      "'its' for neuters");
+  PyChar_addGetSetter("himher", PyChar_gethisher, NULL,
+		      "Returns 'him' if the char is male, 'her' if female, and "
+		      "'it' for neuters");
+  PyChar_addGetSetter("heshe", PyChar_gethisher, NULL,
+		      "Returns 'he' if the char is male, 'she' if female, and "
+		      "'it' for neuters");
 
   // add in all of our methods for the Char class
   PyChar_addMethod("attach", PyChar_attach, METH_VARARGS,
@@ -960,7 +1271,7 @@
 		   "detach an old script from the character.");
   PyChar_addMethod("send", PyChar_send, METH_VARARGS,
 		   "send a message to the character.");
-  PyChar_addMethod("sendarond", PyChar_sendaround, METH_VARARGS,
+  PyChar_addMethod("sendaround", PyChar_sendaround, METH_VARARGS,
 		   "send a message to everyone around the character.");
   PyChar_addMethod("act", PyChar_act, METH_VARARGS,
 		   "make the character perform an action.");
@@ -968,6 +1279,22 @@
 		   "get the value of a special variable the character has.");
   PyChar_addMethod("setvar", PyChar_setvar, METH_VARARGS,
 		   "set the value of a special variable the character has.");
+  PyChar_addMethod("hasvar", PyChar_hasvar, METH_VARARGS,
+		   "return whether or not the character has a given variable.");
+  PyChar_addMethod("deletevar", PyChar_deletevar, METH_VARARGS,
+		   "delete a variable from the character's variable table.");
+  PyChar_addMethod("equip", PyChar_equip, METH_VARARGS,
+		   "equips a character with the given item. Removes the item "
+		   "from whatever it is currently in/on.");
+  PyChar_addMethod("isActing", PyChar_is_acting, METH_VARARGS,
+		   "Returns True if the character is currently taking an "
+		   "action, and False otherwise.");
+  PyChar_addMethod("startAction", PyChar_start_action, METH_VARARGS,
+		   "Begins the character starting a new action");
+  PyChar_addMethod("interrupt", PyChar_interrupt_action, METH_VARARGS,
+		   "Interrupts the character's current action.");
+  PyChar_addMethod("getAuxiliary", PyChar_get_auxiliary, METH_VARARGS,
+		   "get's the specified piece of aux data from the char");
 
   // add in all the getsetters and methods
   makePyType(&PyChar_Type, pychar_getsetters, pychar_methods);
@@ -987,8 +1314,9 @@
     return;
 
   // add the Char class to the module
+  PyTypeObject *type = &PyChar_Type;
   Py_INCREF(&PyChar_Type);
-  PyModule_AddObject(m, "Char", (PyObject *)&PyChar_Type);
+  PyModule_AddObject(m, "Char", (PyObject *)type);
 }
 
 
